﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace BSF_Code_Library.Helpers
{
    class MovingGradient
    {
        private Timer _tmrAnimate = new Timer();
        private Graphics _GFX;
        private LinearGradientBrush _LGB;
        private Rectangle _rect;
        private Color _color1;
        private Color _color2;
        private Control _control;
        private float _gradientAngle;

        public MovingGradient(Control control, float gradientAngle, Color color1, Color color2)
        {
            _tmrAnimate.Interval = 1;
            _tmrAnimate.Tick +=new EventHandler(_tmrAnimate_Tick);
            _gradientAngle = gradientAngle;
            _color1 = color1;
            _color2 = color2;
            _control = control;
            _rect = control.ClientRectangle;
            _GFX = control.CreateGraphics();
        }

        private void _tmrAnimate_Tick(object sender, EventArgs e)
        {
            _rect = new Rectangle(_rect.X + 1, _rect.Y + 1, _rect.Width, _rect.Height);
            _LGB = new LinearGradientBrush(_rect, _color1, _color2, _gradientAngle);
            _LGB.WrapMode = WrapMode.TileFlipX;
            _GFX.FillRectangle(_LGB, _control.ClientRectangle);
        }

        public Color Color1
        {
            get { return _color1; }
            set { _color1 = value; }
        }

        public Color Color2
        {
            get { return _color2; }
            set { _color2 = value; }
        }

        public float GradientAngle
        {
            get { return _gradientAngle; }
            set { _gradientAngle = value; }
        }

        public void StartAnimation()
        {
            _tmrAnimate.Start();
        }

        public void StopAnimation()
        {
            _tmrAnimate.Stop();
        }
    }
}
