﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BSF_Code_Library.Helpers
{
    class RecentList<Type> : List<Type>
    {
        public RecentList()
        {
            // Default capacity is 10
            this.Capacity = 10;
        }

        public RecentList(IEnumerable<Type> items)
        {
            AddRange(items);
            // Auto set capacity
            this.TrimExcess();
        }

        public new void Add(Type item)
        {
            // If at capacity and has more then 0 elements
            if (this.Count == this.Capacity && this.Count != 0)
            {
                // Make room for new item
                this.RemoveAt(0);
            }

            base.Add(item);
        }

        /// <summary>
        /// Inserts the specified item at the start of the collection
        /// </summary>
        public void AddToStart(Type item)
        {
            // If at capacity and has more then 0 elements
            if (this.Count == this.Capacity && this.Count != 0)
            {
                // Make room for new item
                this.RemoveAt(this.Count - 1);
            }

            base.Insert(0, item);
        }

        public new void AddRange(IEnumerable<Type> items) 
        {
            foreach (Type item in items)
            {
                Add(item);
            }
        }
    }
}
