﻿using System;
using System.Collections.Generic;
using System.Text;

namespace BSF_Code_Library.Helpers
{
    class Sylable
    {
        private char[] _word;

        public Sylable(string word)
        {
            //convert string to lower case and store
            //into a character array which we can easily work with
            _word = word.ToLower().ToCharArray();
        }

        /// <summary>
        /// Determines whether or not a char is a vowel
        /// </summary>
        /// <param name="c"></param>
        /// <returns></returns>
        private bool IsCharVowel(char c)
        {
            if (c.Equals('a') || 
                c.Equals('e') || 
                c.Equals('i') || 
                c.Equals('o') || 
                c.Equals('u'))
            {
                return true;
            }
            else return false;
        }

        public int GetCount()
        {
            int count = 0;

            //Loop through characters and check for vowels
            for (int i = 0; i < _word.Length; i++)
            {
                if (!IsCharVowel(_word[i]) && i != 0)
                {
                    if (HasVowelBefore(i))
                    {
                        count++;
                    }
                }
            }

            if (IsCharVowel(_word[_word.Length - 1]))
            {
                count++;
            }

            if (_word[_word.Length - 1] == 'y')
            {
                count++;
            }

            //A word has atleast one sylable
            if (count == 0)
            {
                count = 1;
            }

            return count;
        }

        /// <summary>
        /// Takes in a character index and determines
        /// if a char at index before is a vowel
        /// </summary>
        private bool HasVowelBefore(int i)
        {
            return (IsCharVowel(_word[i - 1]));
        }
    }
}
